package FireTruck2017OnTrigger
{
	function armor::onTrigger(%db, %obj, %slot, %val)
	{
		//SLOT VALUES:
		//0: Left click		(Recognized by a vehicle)
		//1: ???
		//2: Jump			(only recognized while a passenger)
		//3: Crouch			(only recognized while a passenger)
		//4: Right click	(Seems to be recognized in a vehicle, but is for unmount)
		//
		//Val = 1   Activate
		//Val = 0   Release
		
		
		//Player has left-clicked, is mounted, and has no tool
		if(%obj.getClassName()$="Player" && %slot == 0 && %obj.isMounted() && %obj.currTool == -1)
		{
			//If mounted object is a FireTruck2017, and the player is the driver
			%veh = %obj.getObjectMount();
			if(%veh.GetDatablock().getName() $= "FireTruck2017Vehicle" && %obj.getMountNode() == 0)
			{
				if(%val)	//Start of click
				{
					%veh.playAudio(2, FireTruck2017Horn);
					%veh.stopHornSchedule = %veh.schedule(1000, stopAudio, 2);
				}
				else		//Release
				{
					%veh.stopAudio(2);
					cancel(%veh.stopHornSchedule);
				}
			}
		}
		
		return Parent::onTrigger(%db,%obj,%slot,%val);
	}
};
activatePackage(FireTruck2017OnTrigger);
