datablock fxLightData(FireTruck2017HeadLight)
{
	radius = 60;
	brightness = 2;
	color = "1 0.95 0.9 1";
	flareOn = false;
};

datablock fxLightData(FireTruckLight)
{
	uiName = "Fire Truck Light";
	LightOn = true;
	radius = 100;
	brightness = 2;
	color = "1 0.2 0.2";
	FlareOn			= false;
	AnimColor		= true;
	AnimBrightness	= true;
	AnimOffsets		= false;
	AnimRotation	= false;
	AnimRadius		= false;
	LinkFlare		= true;
	LinkFlareSize	= true;
	MinColor		= "1 0 0";
	MaxColor		= "1 0.35 0.35";
	MinBrightness	= 0.25;
	MaxBrightness	= 1.0;
	MinRadius		= 50;
	MaxRadius		= 50;
	StartOffset		= "-5 0 0";
	EndOffset		= "5 0 0";
	MinRotation		= 0;
	MaxRotation		= 359;
	SingleColorKeys	= true;
	RedKeys			= "AAFZFAA";
	GreenKeys		= "";
	BlueKeys		= "";
	BrightnessKeys	= "AVLZLVA";
	//RadiusKeys		= "AZAZAZA";
	OffsetKeys		= "AZAAAAA";
	RotationKeys	= "AZAAAAA";
	ColorTime		= 0.5;
	BrightnessTime	= 0.5;
	RadiusTime		= 0.5;
	OffsetTime		= 1.0;
	RotationTime	= 1.0;
	LerpColor		= true;
	LerpBrightness	= true;
	LerpRadius		= true;
	LerpOffset		= false;
	LerpRotation	= false;
};

function FireTruck2017Vehicle::onTrigger(%this, %veh, %slot, %val)	//Braking
{
	if(%val)
	{	//brake on
		%veh.braking = 1;

		%veh.hidenode(brakelight0);
		%veh.hidenode(brakelight1);
		%veh.unhidenode(brakelight2);
	}
	else
	{	//brake off
		%veh.braking = 0;

		%veh.hidenode(brakelight2);

		if(%veh.headlightState > 0)
			%veh.unhidenode(brakelight1);

		else
			%veh.unhidenode(brakelight0);
	}
}

function FireTruck2017Vehicle::headlights(%this, %veh, %directive, %selection)
{
	switch$(%directive)
	{
		case "next":
		%setlights = %veh.headlightState + 1;
		%veh.headlightState = %veh.headlightState + 1;
		
		case "restore":
		%setlights = %veh.headlightState;
		
		case "select":
		%setlights = %selection;
		%veh.headlightState = %selection;
		
		case "off":
		%setlights = 0;
	}
	
	if(%setlights > 2)
	{
		%setlights = 0;
		%veh.headlightState = 0;
	}
	
	switch(%setlights)
	{
		case 0:		//Headlights off
			%veh.mountedLightBot[7].setMountedLight(none);
			%veh.unhidenode(headlight0);
			//%veh.unhidenode(lights_amberL_0);
			//%veh.unhidenode(lights_amberR_0);

			%veh.hidenode(headlight1);
			//%veh.hidenode(lights_amberL_1);
			//%veh.hidenode(lights_amberR_1);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				%veh.hidenode(brakelight2);
				%veh.hidenode(brakelight1);
				%veh.unhidenode(brakelight0);
			}
		
		case 1:		//Daytime-running lights
			%veh.unhidenode(headlight1);
			//%veh.unhidenode(lights_amberL_1);
			//%veh.unhidenode(lights_amberR_1);

			%veh.hidenode(headlight0);
			//%veh.hidenode(lights_amberL_0);
			//%veh.hidenode(lights_amberR_0);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				%veh.hidenode(brakelight2);
				%veh.hidenode(brakelight0);
				%veh.unhidenode(brakelight1);
			}
		
		case 2:		//Full lights including light source
			%veh.mountedLightBot[7].setMountedLight(FireTruck2017HeadLight);
			
			%veh.hidenode(headlight0);
			//%veh.hidenode(lights_amberL_0);
			//%veh.hidenode(lights_amberR_0);

			%veh.unhidenode(headlight1);
			//%veh.unhidenode(lights_amberL_1);
			//%veh.unhidenode(lights_amberR_1);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				%veh.hidenode(brakelight2);
				%veh.hidenode(brakelight0);
				%veh.unhidenode(brakelight1);
			}
	}
}


/////////////////////////////////////////////////////////////////////////////////

function FireTruck2017Vehicle::turnSignal(%this, %veh, %direction)
{
	if (!isObject(%veh)) return;
	//announce("turnSignal with direction " @ %direction @ " and signalMinor " @ %veh.signalMinor);

	%veh.signal = %direction;	//Other functions must know which direction is being used

	if(%direction == 0)	//0 is a signal to turn off
	{	//TURN OFF SIGNAL
		cancel(%veh.turnSignalSchedule);
		%veh.signalMinor = 0;	//this means lights will begin on "turn on" cycle when next used

		%veh.unhideNode(amberR0);
		%veh.unhideNode(amberL0);
		%veh.hideNode(amberR1);
		%veh.hideNode(amberL1);

		return;
	}	//END OF TURN OFF SIGNAL

	if(%veh.signalMinor == 0)	//If the signal lights were off before this moment. Turn on
	{
		%veh.signalMinor = 1;	//Switch so that the schedule uses the section below
		if(%direction == 1)		//Right side turn on
		{
			%veh.hideNode(amberR0);
			%veh.unhideNode(amberR1);
		}
		else					//Left side turn on
		{
			%veh.hideNode(amberL0);
			%veh.unhideNode(amberL1);
		}
	}
	else	//Signal lights were on before this instant. Turn off
	{
		%veh.signalMinor = 0;	//Switch so that the schedule uses the section above
		if(%direction == 1)		//Right side turn off
		{
			%veh.unhideNode(amberR0);
			%veh.hideNode(amberR1);
		}
		else					//Left side turn off
		{
			%veh.unhideNode(amberL0);
			%veh.hideNode(amberL1);
		}
	}
		
	return %veh.turnSignalSchedule = %this.schedule(300, turnSignal, %veh, %direction);
}