package FireTruck2017Vehicle
{
	function FireTruck2017Vehicle::onAdd(%this, %veh)
	{
		Parent::onAdd(%this, %veh);

		%veh.playThread(0, lightsroot);

		%veh.spawnMountedLightBot(7);
		%veh.spawnMountedLightBot(8);
		
		%veh.lightsActive = 0;
		%veh.headlightState = 1;
		%veh.qWailState = 0;
		%veh.pCallState = 0;

		%veh.setWheelPowered(0,0);
		%veh.setWheelPowered(1,0);
		
		%veh.setWheelTire(0, FireTruck2017Tire);
		%veh.setWheelTire(1, FireTruck2017Tire);
		%veh.setWheelTire(2, FireTruck2017RearTire);
		%veh.setWheelTire(3, FireTruck2017RearTire);


		%veh.hidenode(headlight1);
		%veh.hidenode(amberL1);
		%veh.hidenode(amberR1);
		%veh.hidenode(brakelight1);
		%veh.hidenode(brakelight2);
		%veh.hidenode(reverse1);
		%veh.hidenode(lightbars1);
		
		//%veh.setWheelSpring(0, FireTruck2017Spring);
		//%veh.setWheelSpring(1, FireTruck2017Spring);
		//%veh.setWheelSpring(2, FireTruck2017RearSpring);
		//%veh.setWheelSpring(3, FireTruck2017RearSpring);
	}
};
activatePackage(FireTruck2017Vehicle);

package onDriverEnterPackage
{
	function armor::onMount(%this, %obj, %vehicle, %node)
	{
		Parent::onMount(%this, %obj, %vehicle, %node);
		
		if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
			%vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
	}

};
activatePackage(onDriverEnterPackage);

function FireTruck2017Vehicle::onDriverEnter(%data, %veh)
{	
	//onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
	//The hasDriver variable makes it so these things are done only one time each.
	if(!%veh.hasDriver)
	{
		%veh.hasDriver = 1;
		
		%data.headlights(%veh, "restore");
		
		%data.SpeedCheck(%veh);
	}
}

function FireTruck2017Vehicle::onDriverLeave(%data, %veh)
{		
	if(%veh.hasDriver)
	{
		%veh.hasDriver = 0;

		%veh.braking = 0;
		%veh.hidenode(brakelight2);
		
		%veh.reversing = 0;
		%veh.unhidenode(reverse0);
		%veh.hidenode(reverse1);

		cancel(%veh.SpeedCheckSchedule);
		%data.turnSignal(%veh, 0);
		%data.headlights(%veh, "off");

		%veh.stopAudio(0);
		%veh.stopAudio(1);
		%veh.stopAudio(2);
		%veh.qWailState = 0;
		%veh.pCallState = 0;
	}
}

function FireTruck2017Vehicle::onRemove(%data, %veh)
{
	%veh.removeMountedLightBot(7);
	%veh.removeMountedLightBot(8);
}

function FireTruck2017Vehicle::SpeedCheck(%data, %veh)
{
	if(isEventPending(%veh.SpeedCheckSchedule)) return;
	if(!isObject(%veh)) return;
	
	%veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
	
	if(!%veh.reversing && %veh.speed <= -3)
	{
		%veh.hidenode(reverse0);
		%veh.unhidenode(reverse1);
		%veh.reversing = 1;
	}
	else if(%veh.reversing && %veh.speed > -0.1)
	{
		%veh.unhidenode(reverse0);
		%veh.hidenode(reverse1);
		%veh.reversing = 0;
	}
	
	%veh.SpeedCheckSchedule = %data.schedule(111, "SpeedCheck", %veh);
}